OpenTTD: src/toolbar_gui.cpp File Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

Data Structures | Typedefs | Enumerations | Functions | Variables
toolbar_gui.cpp File Reference

Code related to the (main) toolbar. More...

`#include "stdafx.h"`
`#include "gui.h"`
`#include "window_gui.h"`
`#include "window_func.h"`
`#include "viewport_func.h"`
`#include "command_func.h"`
`#include "vehicle_gui.h"`
`#include "rail_gui.h"`
`#include "road_gui.h"`
`#include "date_func.h"`
`#include "vehicle_func.h"`
`#include "sound_func.h"`
`#include "terraform_gui.h"`
`#include "strings_func.h"`
`#include "company_func.h"`
`#include "company_gui.h"`
`#include "vehicle_base.h"`
`#include "cheat_func.h"`
`#include "transparency_gui.h"`
`#include "screenshot.h"`
`#include "signs_func.h"`
`#include "fios.h"`
`#include "console_gui.h"`
`#include "news_gui.h"`
`#include "ai/ai_gui.hpp"`
`#include "tilehighlight_func.h"`
`#include "smallmap_gui.h"`
`#include "graph_gui.h"`
`#include "textbuf_gui.h"`
`#include "linkgraph/linkgraph_gui.h"`
`#include "newgrf_debug.h"`
`#include "hotkeys.h"`
`#include "engine_base.h"`
`#include "highscore.h"`
`#include "game/game.hpp"`
`#include "goal_base.h"`
`#include "story_base.h"`
`#include "toolbar_gui.h"`
`#include "widgets/toolbar_widget.h"`
`#include "network/network.h"`
`#include "network/network_gui.h"`
`#include "network/network_func.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
class | DropDownListCheckedItem
| Drop down list entry for showing a checked/unchecked toggle item. More...
class | DropDownListCompanyItem
| Drop down list entry for showing a company entry, with companies 'blob'. More...
class | NWidgetToolbarContainer
| Full blown container to make it behave exactly as we want :) More...
class | NWidgetMainToolbarContainer
| Container for the 'normal' main toolbar. More...
class | NWidgetScenarioToolbarContainer
| Container for the scenario editor's toolbar. More...
struct | MainToolbarWindow
| Main toolbar. More...
struct | ScenarioEditorToolbarWindow

## Typedefs
typedef CallBackFunction | MenuClickedProc (int index)
typedef CallBackFunction | ToolbarButtonProc (Window *w)

## Enumerations
enum | ToolbarMode { TB_NORMAL, TB_UPPER, TB_LOWER }
| Toobar modes.
enum | CallBackFunction { CBF_NONE, CBF_PLACE_SIGN, CBF_PLACE_LANDINFO }
| Callback functions. More...
enum | OptionMenuEntries { OME_GAMEOPTIONS, OME_SETTINGS, OME_SCRIPT_SETTINGS, OME_NEWGRFSETTINGS, OME_TRANSPARENCIES, OME_SHOW_TOWNNAMES, OME_SHOW_STATIONNAMES, OME_SHOW_WAYPOINTNAMES, OME_SHOW_SIGNS, OME_SHOW_COMPETITOR_SIGNS, OME_FULL_ANIMATION, OME_FULL_DETAILS, OME_TRANSPARENTBUILDINGS, OME_SHOW_STATIONSIGNS }
| Game Option button menu entries.
enum | SaveLoadEditorMenuEntries { SLEME_SAVE_SCENARIO = 0, SLEME_LOAD_SCENARIO, SLEME_SAVE_HEIGHTMAP, SLEME_LOAD_HEIGHTMAP, SLEME_EXIT_TOINTRO, SLEME_EXIT_GAME = 6, SLEME_MENUCOUNT }
| SaveLoad entries in scenario editor mode.
enum | SaveLoadNormalMenuEntries { SLNME_SAVE_GAME = 0, SLNME_LOAD_GAME, SLNME_EXIT_TOINTRO, SLNME_EXIT_GAME = 4, SLNME_MENUCOUNT }
| SaveLoad entries in normal game mode.
enum | MapMenuEntries { MME_SHOW_SMALLMAP = 0, MME_SHOW_EXTRAVIEWPORTS, MME_SHOW_LINKGRAPH, MME_SHOW_SIGNLISTS, MME_SHOW_TOWNDIRECTORY, MME_SHOW_INDUSTRYDIRECTORY }
enum | MainToolbarHotkeys { MTHK_PAUSE, MTHK_FASTFORWARD, MTHK_SETTINGS, MTHK_SAVEGAME, MTHK_LOADGAME, MTHK_SMALLMAP, MTHK_TOWNDIRECTORY, MTHK_SUBSIDIES, MTHK_STATIONS, MTHK_FINANCES, MTHK_COMPANIES, MTHK_STORY, MTHK_GOAL, MTHK_GRAPHS, MTHK_LEAGUE, MTHK_INDUSTRIES, MTHK_TRAIN_LIST, MTHK_ROADVEH_LIST, MTHK_SHIP_LIST, MTHK_AIRCRAFT_LIST, MTHK_ZOOM_IN, MTHK_ZOOM_OUT, MTHK_BUILD_RAIL, MTHK_BUILD_ROAD, MTHK_BUILD_DOCKS, MTHK_BUILD_AIRPORT, MTHK_BUILD_TREES, MTHK_MUSIC, MTHK_AI_DEBUG, MTHK_SMALL_SCREENSHOT, MTHK_ZOOMEDIN_SCREENSHOT, MTHK_DEFAULTZOOM_SCREENSHOT, MTHK_GIANT_SCREENSHOT, MTHK_CHEATS, MTHK_TERRAFORM, MTHK_EXTRA_VIEWPORT, MTHK_CLIENT_LIST, MTHK_SIGN_LIST }
enum | MainToolbarEditorHotkeys { MTEHK_PAUSE, MTEHK_FASTFORWARD, MTEHK_SETTINGS, MTEHK_SAVEGAME, MTEHK_GENLAND, MTEHK_GENTOWN, MTEHK_GENINDUSTRY, MTEHK_BUILD_ROAD, MTEHK_BUILD_DOCKS, MTEHK_BUILD_TREES, MTEHK_SIGN, MTEHK_MUSIC, MTEHK_LANDINFO, MTEHK_SMALL_SCREENSHOT, MTEHK_ZOOMEDIN_SCREENSHOT, MTEHK_DEFAULTZOOM_SCREENSHOT, MTEHK_GIANT_SCREENSHOT, MTEHK_ZOOM_IN, MTEHK_ZOOM_OUT, MTEHK_TERRAFORM, MTEHK_SMALLMAP, MTEHK_EXTRA_VIEWPORT }

## Functions
static void | PopupMainToolbMenu (Window *w, int widget, DropDownList *list, int def)
| Pop up a generic text only menu.
static void | PopupMainToolbMenu (Window *w, int widget, StringID string, int count)
| Pop up a generic text only menu.
static void | PopupMainCompanyToolbMenu (Window *w, int widget, int grey=0, bool include_spectator=false)
| Pop up a generic company list menu.
static CallBackFunction | SelectSignTool ()
static CallBackFunction | ToolbarPauseClick (Window *w)
static CallBackFunction | ToolbarFastForwardClick (Window *w)
| Toggle fast forward mode.
static CallBackFunction | ToolbarOptionsClick (Window *w)
| Handle click on Options button in toolbar.
static CallBackFunction | MenuClickSettings (int index)
| Handle click on one of the entries in the Options button menu.
static CallBackFunction | ToolbarSaveClick (Window *w)
| Handle click on Save button in toolbar in normal game mode.
static CallBackFunction | ToolbarScenSaveOrLoad (Window *w)
| Handle click on SaveLoad button in toolbar in the scenario editor.
static CallBackFunction | MenuClickSaveLoad (int index=0)
| Handle click on one of the entries in the SaveLoad menu.
static CallBackFunction | ToolbarMapClick (Window *w)
static CallBackFunction | ToolbarScenMapTownDir (Window *w)
static CallBackFunction | MenuClickMap (int index)
| Handle click on one of the entries in the Map menu.
static CallBackFunction | ToolbarTownClick (Window *w)
static CallBackFunction | MenuClickTown (int index)
| Handle click on one of the entries in the Town menu.
static CallBackFunction | ToolbarSubsidiesClick (Window *w)
static CallBackFunction | MenuClickSubsidies (int index)
| Handle click on the entry in the Subsidies menu.
static CallBackFunction | ToolbarStationsClick (Window *w)
static CallBackFunction | MenuClickStations (int index)
| Handle click on the entry in the Stations menu.
static CallBackFunction | ToolbarFinancesClick (Window *w)
static CallBackFunction | MenuClickFinances (int index)
| Handle click on the entry in the finances overview menu.
static CallBackFunction | ToolbarCompaniesClick (Window *w)
static CallBackFunction | MenuClickCompany (int index)
| Handle click on the entry in the Company menu.
static CallBackFunction | ToolbarStoryClick (Window *w)
static CallBackFunction | MenuClickStory (int index)
| Handle click on the entry in the Story menu.
static CallBackFunction | ToolbarGoalClick (Window *w)
static CallBackFunction | MenuClickGoal (int index)
| Handle click on the entry in the Goal menu.
static CallBackFunction | ToolbarGraphsClick (Window *w)
static CallBackFunction | MenuClickGraphs (int index)
| Handle click on the entry in the Graphs menu.
static CallBackFunction | ToolbarLeagueClick (Window *w)
static CallBackFunction | MenuClickLeague (int index)
| Handle click on the entry in the CompanyLeague menu.
static CallBackFunction | ToolbarIndustryClick (Window *w)
static CallBackFunction | MenuClickIndustry (int index)
| Handle click on the entry in the Industry menu.
static void | ToolbarVehicleClick (Window *w, VehicleType veh)
static CallBackFunction | ToolbarTrainClick (Window *w)
static CallBackFunction | MenuClickShowTrains (int index)
| Handle click on the entry in the Train menu.
static CallBackFunction | ToolbarRoadClick (Window *w)
static CallBackFunction | MenuClickShowRoad (int index)
| Handle click on the entry in the Road Vehicles menu.
static CallBackFunction | ToolbarShipClick (Window *w)
static CallBackFunction | MenuClickShowShips (int index)
| Handle click on the entry in the Ships menu.
static CallBackFunction | ToolbarAirClick (Window *w)
static CallBackFunction | MenuClickShowAir (int index)
| Handle click on the entry in the Aircraft menu.
static CallBackFunction | ToolbarZoomInClick (Window *w)
static CallBackFunction | ToolbarZoomOutClick (Window *w)
static CallBackFunction | ToolbarBuildRailClick (Window *w)
static CallBackFunction | MenuClickBuildRail (int index)
| Handle click on the entry in the Build Rail menu.
static CallBackFunction | ToolbarBuildRoadClick (Window *w)
static CallBackFunction | MenuClickBuildRoad (int index)
| Handle click on the entry in the Build Road menu.
static CallBackFunction | ToolbarBuildWaterClick (Window *w)
static CallBackFunction | MenuClickBuildWater (int index)
| Handle click on the entry in the Build Waterways menu.
static CallBackFunction | ToolbarBuildAirClick (Window *w)
static CallBackFunction | MenuClickBuildAir (int index)
| Handle click on the entry in the Build Air menu.
static CallBackFunction | ToolbarForestClick (Window *w)
static CallBackFunction | MenuClickForest (int index)
| Handle click on the entry in the landscaping menu.
static CallBackFunction | ToolbarMusicClick (Window *w)
static CallBackFunction | MenuClickMusicWindow (int index)
| Handle click on the entry in the Music menu.
static CallBackFunction | ToolbarNewspaperClick (Window *w)
static CallBackFunction | MenuClickNewspaper (int index)
| Handle click on the entry in the Newspaper menu.
static CallBackFunction | PlaceLandBlockInfo ()
static CallBackFunction | ToolbarHelpClick (Window *w)
static void | MenuClickSmallScreenshot ()
static void | ScreenshotConfirmCallback (Window *w, bool confirmed)
| Callback on the confirmation window for huge screenshots.
static void | MenuClickLargeWorldScreenshot (ScreenshotType t)
| Make a screenshot of the world.
void | ToggleBoundingBoxes ()
| Toggle drawing of sprites' bounding boxes.
void | ToggleDirtyBlocks ()
| Toggle drawing of the dirty blocks.
void | SetStartingYear (Year year)
| Set the starting year for a scenario.
static CallBackFunction | MenuClickHelp (int index)
| Choose the proper callback function for the main toolbar's help menu.
static CallBackFunction | ToolbarSwitchClick (Window *w)
static CallBackFunction | ToolbarScenDatePanel (Window *w)
| Called when clicking at the date panel of the scenario editor toolbar.
static CallBackFunction | ToolbarScenDateBackward (Window *w)
static CallBackFunction | ToolbarScenDateForward (Window *w)
static CallBackFunction | ToolbarScenGenLand (Window *w)
static CallBackFunction | ToolbarScenGenTown (Window *w)
static CallBackFunction | ToolbarScenGenIndustry (Window *w)
static CallBackFunction | ToolbarScenBuildRoad (Window *w)
static CallBackFunction | ToolbarScenBuildDocks (Window *w)
static CallBackFunction | ToolbarScenPlantTrees (Window *w)
static CallBackFunction | ToolbarScenPlaceSign (Window *w)
static CallBackFunction | ToolbarBtn_NULL (Window *w)
static NWidgetBase * | MakeMainToolbar (int *biggest_index)
static NWidgetBase * | MakeScenarioToolbar (int *biggest_index)
void | AllocateToolbar ()
| Allocate the toolbar.

## Variables
uint | _toolbar_width = 0
| Width of the toolbar, shared by statusbar.
RailType | _last_built_railtype
RoadType | _last_built_roadtype
static ScreenshotType | _confirmed_screenshot_type
| Screenshot type the current query is about to confirm.
static const int | CTMN_CLIENT_LIST = -1
| Enum for the Company Toolbar's network related buttons.
static const int | CTMN_NEW_COMPANY = -2
| Create a new company.
static const int | CTMN_SPECTATE = -3
| Become spectator.
static const int | CTMN_SPECTATOR = -4
| Show a company window as spectator.
static ToolbarMode | _toolbar_mode
static MenuClickedProc *const | _menu_clicked_procs []
static ToolbarButtonProc *const | _toolbar_button_procs []
const uint16 | _maintoolbar_pause_keys [] = {WKC_F1, WKC_PAUSE, 0}
const uint16 | _maintoolbar_zoomin_keys [] = {WKC_NUM_PLUS, WKC_EQUALS, WKC_SHIFT | WKC_EQUALS, WKC_SHIFT | WKC_F5, 0}
const uint16 | _maintoolbar_zoomout_keys [] = {WKC_NUM_MINUS, WKC_MINUS, WKC_SHIFT | WKC_MINUS, WKC_SHIFT | WKC_F6, 0}
const uint16 | _maintoolbar_smallmap_keys [] = {WKC_F4, 'M', 0}
static Hotkey | maintoolbar_hotkeys []
static const NWidgetPart | _nested_toolbar_normal_widgets []
static WindowDesc | _toolb_normal_desc (WDP_MANUAL, NULL, 0, 0, WC_MAIN_TOOLBAR, WC_NONE, WDF_NO_FOCUS, _nested_toolbar_normal_widgets, lengthof(_nested_toolbar_normal_widgets),&MainToolbarWindow::hotkeys)
static ToolbarButtonProc *const | _scen_toolbar_button_procs []
static Hotkey | scenedit_maintoolbar_hotkeys []
static const NWidgetPart | _nested_toolb_scen_inner_widgets []
static const NWidgetPart | _nested_toolb_scen_widgets []
static WindowDesc | _toolb_scen_desc (WDP_MANUAL, NULL, 0, 0, WC_MAIN_TOOLBAR, WC_NONE, WDF_NO_FOCUS, _nested_toolb_scen_widgets, lengthof(_nested_toolb_scen_widgets),&ScenarioEditorToolbarWindow::hotkeys)

## Detailed Description

Code related to the (main) toolbar.

Definition in file toolbar_gui.cpp.

## Enumeration Type Documentation

enum CallBackFunction

Callback functions.

Definition at line 76 of file toolbar_gui.cpp.

## Function Documentation

void AllocateToolbar | ( |  | ) |

Allocate the toolbar.

Definition at line 2236 of file toolbar_gui.cpp.

References ROADTYPE_ROAD.

Referenced by ShowVitalWindows().

static NWidgetBase* MakeMainToolbar | ( | int * | biggest_index | ) |
| static

Sprites to use for the different toolbar buttons

Definition at line 1859 of file toolbar_gui.cpp.

References NWidgetContainer::Add(), WID_TN_END, WID_TN_SAVE, WID_TN_SWITCH_BAR, WWT_IMGBTN, and WWT_IMGBTN_2.

static CallBackFunction MenuClickBuildAir | ( | int | index | ) |
| static

Handle click on the entry in the Build Air menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 957 of file toolbar_gui.cpp.

References ShowBuildAirToolbar().

static CallBackFunction MenuClickBuildRail | ( | int | index | ) |
| static

Handle click on the entry in the Build Rail menu.

Parameters

  index | RailType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 879 of file toolbar_gui.cpp.

References ShowBuildRailToolbar().

static CallBackFunction MenuClickBuildRoad | ( | int | index | ) |
| static

Handle click on the entry in the Build Road menu.

Parameters

  index | RoadType to show the build toolbar for.

Returns
  #CBF_NONE

Definition at line 916 of file toolbar_gui.cpp.

References ShowBuildRoadToolbar().

static CallBackFunction MenuClickBuildWater | ( | int | index | ) |
| static

Handle click on the entry in the Build Waterways menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 937 of file toolbar_gui.cpp.

References ShowBuildDocksToolbar().

static CallBackFunction MenuClickCompany | ( | int | index | ) |
| static

Handle click on the entry in the Company menu.

Parameters

  index | Menu entry to handle.

Returns
  #CBF_NONE

Definition at line 599 of file toolbar_gui.cpp.

References _local_company, _network_own_client_id, _network_server, _networking, CLIENT_ID_SERVER, CMD_COMPANY_CTRL, COMPANY_SPECTATOR, CTMN_CLIENT_LIST, CTMN_NEW_COMPANY, CTMN_SPECTATE, DoCommandP(), MarkWholeScreenDirty(), NetworkClientRequestMove(), NetworkSendCommand(), NetworkServerDoMove(), and ShowCompany().

static CallBackFunction MenuClickFinances | ( | int | index | ) |
| static

Handle click on the entry in the finances overview menu.

Parameters

  index | CompanyID to show finances for.

Returns
  #CBF_NONE

Definition at line 579 of file toolbar_gui.cpp.

References ShowCompanyFinances().

static CallBackFunction MenuClickForest | ( | int | index | ) |
| static

Handle click on the entry in the landscaping menu.

Parameters

  index | Menu entry clicked.

Returns
  #CBF_NONE

Definition at line 977 of file toolbar_gui.cpp.

References ShowTerraformToolbar().

static CallBackFunction MenuClickGoal | ( | int | index | ) |
| static

Handle click on the entry in the Goal menu.

Parameters

  index | CompanyID to show story book for

Returns
  #CBF_NONE

Definition at line 665 of file toolbar_gui.cpp.

References CTMN_SPECTATOR, INVALID_COMPANY, and ShowGoalsList().

static CallBackFunction MenuClickGraphs | ( | int | index | ) |
| static

Handle click on the entry in the Graphs menu.

Parameters

  index | Graph to show.

Returns
  #CBF_NONE

Definition at line 685 of file toolbar_gui.cpp.

static CallBackFunction MenuClickHelp | ( | int | index | ) |
| static

Choose the proper callback function for the main toolbar's help menu.

Parameters

  index | The menu index which was selected.

Returns
  CBF_NONE

Definition at line 1137 of file toolbar_gui.cpp.

References IConsoleSwitch(), MenuClickLargeWorldScreenshot(), SC_DEFAULTZOOM, SC_WORLD, SC_ZOOMEDIN, ShowAIDebugWindow(), ShowSpriteAlignerWindow(), ToggleBoundingBoxes(), and ToggleDirtyBlocks().

static CallBackFunction MenuClickIndustry | ( | int | index | ) |
| static

Handle click on the entry in the Industry menu.

Parameters

  index | Menu entry number.

Returns
  #CBF_NONE

Definition at line 740 of file toolbar_gui.cpp.

References ShowIndustryCargoesWindow().

static void MenuClickLargeWorldScreenshot | ( | ScreenshotType | t | ) |
| static

Make a screenshot of the world.

Ask for confirmation if the screenshot will be huge.

Parameters

  t | Screenshot type: World or viewport screenshot

Definition at line 1069 of file toolbar_gui.cpp.

References _confirmed_screenshot_type, ViewPort::height, MakeScreenshot(), ScreenshotConfirmCallback(), SetDParam(), SetupScreenshotViewport(), ShowQuery(), and ViewPort::width.

Referenced by MenuClickHelp(), MainToolbarWindow::OnHotkey(), and ScenarioEditorToolbarWindow::OnHotkey().

static CallBackFunction MenuClickLeague | ( | int | index | ) |
| static

Handle click on the entry in the CompanyLeague menu.

Parameters

  index | Menu entry number.

Returns
  #CBF_NONE

Definition at line 715 of file toolbar_gui.cpp.

References ShowHighscoreTable().

static CallBackFunction MenuClickMap | ( | int | index | ) |
| static

Handle click on one of the entries in the Map menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 485 of file toolbar_gui.cpp.

References ShowExtraViewPortWindow(), ShowLinkGraphLegend(), ShowSignList(), and ShowSmallMap().

static CallBackFunction MenuClickMusicWindow | ( | int | index | ) |
| static

Handle click on the entry in the Music menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 1001 of file toolbar_gui.cpp.

static CallBackFunction MenuClickNewspaper | ( | int | index | ) |
| static

Handle click on the entry in the Newspaper menu.

Parameters

  index | Menu entry clicked.

Returns
  #CBF_NONE

Definition at line 1021 of file toolbar_gui.cpp.

References ShowLastNewsMessage(), and ShowMessageHistory().

static CallBackFunction MenuClickSaveLoad | ( | int | index = `0` | ) |
| static

Handle click on one of the entries in the SaveLoad menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 423 of file toolbar_gui.cpp.

References ShowSaveLoadDialog(), SLD_LOAD_GAME, SLD_LOAD_HEIGHTMAP, SLD_LOAD_SCENARIO, SLD_SAVE_GAME, SLD_SAVE_HEIGHTMAP, and SLD_SAVE_SCENARIO.

Referenced by MainToolbarWindow::OnHotkey(), and ScenarioEditorToolbarWindow::OnHotkey().

static CallBackFunction MenuClickSettings | ( | int | index | ) |
| static

Handle click on one of the entries in the Options button menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 343 of file toolbar_gui.cpp.

References _display_opt, _grfconfig, _networking, _settings_client, CheckBlitter(), DO_FULL_ANIMATION, DO_FULL_DETAIL, DO_SHOW_COMPETITOR_SIGNS, DO_SHOW_SIGNS, DO_SHOW_STATION_NAMES, DO_SHOW_TOWN_NAMES, DO_SHOW_WAYPOINT_NAMES, ClientSettings::gui, InvalidateWindowClassesData(), MarkWholeScreenDirty(), ShowAIConfigWindow(), ShowGameOptions(), ShowGameSettings(), ShowNewGRFSettings(), ShowTransparencyToolbar(), TO_HOUSES, TO_SIGNS, ToggleBit(), ToggleTransparency(), GUISettings::UserIsAllowedToChangeNewGRFs(), and WC_SIGN_LIST.

static CallBackFunction MenuClickShowAir | ( | int | index | ) |
| static

Handle click on the entry in the Aircraft menu.

Parameters

  index | CompanyID to show aircraft list for.

Returns
  #CBF_NONE

Definition at line 836 of file toolbar_gui.cpp.

References VEH_AIRCRAFT.

static CallBackFunction MenuClickShowRoad | ( | int | index | ) |
| static

Handle click on the entry in the Road Vehicles menu.

Parameters

  index | CompanyID to show road vehicles list for.

Returns
  #CBF_NONE

Definition at line 796 of file toolbar_gui.cpp.

References VEH_ROAD.

static CallBackFunction MenuClickShowShips | ( | int | index | ) |
| static

Handle click on the entry in the Ships menu.

Parameters

  index | CompanyID to show ship list for.

Returns
  #CBF_NONE

Definition at line 816 of file toolbar_gui.cpp.

References VEH_SHIP.

static CallBackFunction MenuClickShowTrains | ( | int | index | ) |
| static

Handle click on the entry in the Train menu.

Parameters

  index | CompanyID to show train list for.

Returns
  #CBF_NONE

Definition at line 776 of file toolbar_gui.cpp.

References VEH_TRAIN.

static CallBackFunction MenuClickStations | ( | int | index | ) |
| static

Handle click on the entry in the Stations menu.

Parameters

  index | CompanyID to show station list for

Returns
  #CBF_NONE

Definition at line 559 of file toolbar_gui.cpp.

References ShowCompanyStations().

static CallBackFunction MenuClickStory | ( | int | index | ) |
| static

Handle click on the entry in the Story menu.

Parameters

  index | CompanyID to show story book for

Returns
  #CBF_NONE

Definition at line 645 of file toolbar_gui.cpp.

References CTMN_SPECTATOR, INVALID_COMPANY, and ShowStoryBook().

static CallBackFunction MenuClickSubsidies | ( | int | index | ) |
| static

Handle click on the entry in the Subsidies menu.

Parameters

  index | Unused.

Returns
  #CBF_NONE

Definition at line 537 of file toolbar_gui.cpp.

static CallBackFunction MenuClickTown | ( | int | index | ) |
| static

Handle click on one of the entries in the Town menu.

Parameters

  index | Index being clicked.

Returns
  #CBF_NONE

Definition at line 512 of file toolbar_gui.cpp.

References _settings_game, GameSettings::economy, EconomySettings::found_town, and TF_FORBIDDEN.

static void PopupMainCompanyToolbMenu | ( | Window * | w,
|  | int | widget,
|  | int | grey = `0`,
|  | bool | include_spectator = `false`
| ) |  |
| static

Pop up a generic company list menu.

Parameters

  w | The toolbar window.
  widget | The button widget id.
  grey | A bitbask of which items to mark as disabled.
  include_spectator | If true, a spectator option is included in the list.

Definition at line 212 of file toolbar_gui.cpp.

References _local_company, _networking, SmallVector< T, S >::Append(), COMPANY_FIRST, COMPANY_SPECTATOR, CTMN_CLIENT_LIST, CTMN_NEW_COMPANY, CTMN_SPECTATE, CTMN_SPECTATOR, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), MAX_COMPANIES, NetworkMaxCompaniesReached(), NetworkMaxSpectatorsReached(), PopupMainToolbMenu(), and WID_TN_COMPANIES.

static void PopupMainToolbMenu | ( | Window * | w,
|  | int | widget,
|  | DropDownList * | list,
|  | int | def
| ) |  |
| static

Pop up a generic text only menu.

Parameters

  w | Toolbar
  widget | Toolbar button
  list | List of items
  def | Default item

Definition at line 177 of file toolbar_gui.cpp.

References _settings_client, SoundSettings::click_beep, ShowDropDownList(), and ClientSettings::sound.

Referenced by PopupMainCompanyToolbMenu(), PopupMainToolbMenu(), ToolbarSaveClick(), and ToolbarScenSaveOrLoad().

static void PopupMainToolbMenu | ( | Window * | w,
|  | int | widget,
|  | StringID | string,
|  | int | count
| ) |  |
| static

Pop up a generic text only menu.

Parameters

  w | Toolbar
  widget | Toolbar button
  string | String for the first item in the menu
  count | Number of items in the menu

Definition at line 190 of file toolbar_gui.cpp.

References SmallVector< T, S >::Append(), and PopupMainToolbMenu().

static void ScreenshotConfirmCallback | ( | Window * | w,
|  | bool | confirmed
| ) |  |
| static

Callback on the confirmation window for huge screenshots.

Parameters

  w | Window with viewport
  confirmed | true on confirmation

Definition at line 1059 of file toolbar_gui.cpp.

References _confirmed_screenshot_type, and MakeScreenshot().

Referenced by MenuClickLargeWorldScreenshot().

void SetStartingYear | ( | Year | year | ) |

Set the starting year for a scenario.

Parameters

  year | New starting year.

Definition at line 1123 of file toolbar_gui.cpp.

References _date, _settings_game, Clamp(), ConvertYMDToDate(), GameSettings::game_creation, LinkGraphSchedule::instance, MAX_YEAR, MIN_YEAR, SetDate(), LinkGraphSchedule::ShiftDates(), and GameCreationSettings::starting_year.

Referenced by ScenarioEditorToolbarWindow::OnQueryTextFinished().

void ToggleBoundingBoxes | ( |  | ) |

Toggle drawing of sprites' bounding boxes.

Note
  has only an effect when newgrf_developer_tools are active.

Function is found here and not in viewport.cpp in order to avoid importing the settings structs to there.

Definition at line 1092 of file toolbar_gui.cpp.

References _settings_client, ClientSettings::gui, MarkWholeScreenDirty(), and GUISettings::newgrf_developer_tools.

Referenced by MenuClickHelp(), and MainWindow::OnHotkey().

void ToggleDirtyBlocks | ( |  | ) |

Toggle drawing of the dirty blocks.

Note
  has only an effect when newgrf_developer_tools are active.

Function is found here and not in viewport.cpp in order to avoid importing the settings structs to there.

Definition at line 1109 of file toolbar_gui.cpp.

References _settings_client, ClientSettings::gui, MarkWholeScreenDirty(), and GUISettings::newgrf_developer_tools.

Referenced by MenuClickHelp(), and MainWindow::OnHotkey().

static CallBackFunction ToolbarFastForwardClick | ( | Window * | w | ) |
| static

Toggle fast forward mode.

Parameters

  w | Unused.

Returns
  #CBF_NONE

Definition at line 277 of file toolbar_gui.cpp.

References _settings_client, SoundSettings::click_beep, and ClientSettings::sound.

Referenced by MainToolbarWindow::OnHotkey(), and ScenarioEditorToolbarWindow::OnHotkey().

static CallBackFunction ToolbarOptionsClick | ( | Window * | w | ) |
| static

Handle click on Options button in toolbar.

Parameters

  w | parent window the shown Drop down list is attached to.

Returns
  #CBF_NONE

Definition at line 310 of file toolbar_gui.cpp.

References _display_opt, _network_server, _networking, _settings_client, SmallVector< T, S >::Append(), SoundSettings::click_beep, DO_FULL_ANIMATION, DO_FULL_DETAIL, DO_SHOW_COMPETITOR_SIGNS, DO_SHOW_SIGNS, DO_SHOW_STATION_NAMES, DO_SHOW_TOWN_NAMES, DO_SHOW_WAYPOINT_NAMES, HasBit(), IsTransparencySet(), ShowDropDownList(), ClientSettings::sound, TO_HOUSES, TO_SIGNS, and WID_TN_SETTINGS.

static CallBackFunction ToolbarSaveClick | ( | Window * | w | ) |
| static

Handle click on Save button in toolbar in normal game mode.

Parameters

  w | parent window the shown save dialogue is attached to.

Returns
  #CBF_NONE

Definition at line 399 of file toolbar_gui.cpp.

References PopupMainToolbMenu(), and WID_TN_SAVE.

static CallBackFunction ToolbarScenSaveOrLoad | ( | Window * | w | ) |
| static

Handle click on SaveLoad button in toolbar in the scenario editor.

Parameters

  w | parent window the shown save dialogue is attached to.

Returns
  #CBF_NONE

Definition at line 411 of file toolbar_gui.cpp.

References PopupMainToolbMenu(), and WID_TE_SAVE.

## Variable Documentation

const NWidgetPart _nested_toolb_scen_widgets[]
| static

Initial value:
{
NWidgetFunction(MakeScenarioToolbar),
}

Definition at line 2223 of file toolbar_gui.cpp.

const NWidgetPart _nested_toolbar_normal_widgets[]
| static

Initial value:
{
NWidgetFunction(MakeMainToolbar),
}

Definition at line 1907 of file toolbar_gui.cpp.

uint _toolbar_width = 0

Width of the toolbar, shared by statusbar.

Definition at line 61 of file toolbar_gui.cpp.

Referenced by StatusBarWindow::FindWindowPlacementAndResize(), NetworkChatWindow::FindWindowPlacementAndResize(), MainToolbarWindow::FindWindowPlacementAndResize(), ScenarioEditorToolbarWindow::FindWindowPlacementAndResize(), RelocateAllWindows(), and NWidgetToolbarContainer::SetupSmallestSize().

const int CTMN_CLIENT_LIST = -1
| static

Enum for the Company Toolbar's network related buttons.

Show the client list

Definition at line 200 of file toolbar_gui.cpp.

Referenced by MenuClickCompany(), and PopupMainCompanyToolbMenu().

Hotkey scenedit_maintoolbar_hotkeys[]
| static

Initial value:
{
Hotkey(_maintoolbar_pause_keys, "pause", MTEHK_PAUSE),
Hotkey((uint16)0, "fastforward", MTEHK_FASTFORWARD),
Hotkey(WKC_F2, "settings", MTEHK_SETTINGS),
Hotkey(WKC_F3, "saveload", MTEHK_SAVEGAME),
Hotkey(WKC_F4, "gen_land", MTEHK_GENLAND),
Hotkey(WKC_F5, "gen_town", MTEHK_GENTOWN),
Hotkey(WKC_F6, "gen_industry", MTEHK_GENINDUSTRY),
Hotkey(WKC_F7, "build_road", MTEHK_BUILD_ROAD),
Hotkey(WKC_F8, "build_docks", MTEHK_BUILD_DOCKS),
Hotkey(WKC_F9, "build_trees", MTEHK_BUILD_TREES),
Hotkey(WKC_F10, "build_sign", MTEHK_SIGN),
Hotkey(WKC_F11, "music", MTEHK_MUSIC),
Hotkey(WKC_F12, "land_info", MTEHK_LANDINFO),
Hotkey(WKC_CTRL | 'S', "small_screenshot", MTEHK_SMALL_SCREENSHOT),
Hotkey(WKC_CTRL | 'P', "zoomedin_screenshot", MTEHK_ZOOMEDIN_SCREENSHOT),
Hotkey(WKC_CTRL | 'D', "defaultzoom_screenshot", MTEHK_DEFAULTZOOM_SCREENSHOT),
Hotkey((uint16)0, "giant_screenshot", MTEHK_GIANT_SCREENSHOT),
Hotkey(_maintoolbar_zoomin_keys, "zoomin", MTEHK_ZOOM_IN),
Hotkey(_maintoolbar_zoomout_keys, "zoomout", MTEHK_ZOOM_OUT),
Hotkey('L', "terraform", MTEHK_TERRAFORM),
Hotkey('M', "smallmap", MTEHK_SMALLMAP),
Hotkey('V', "extra_viewport", MTEHK_EXTRA_VIEWPORT),
HOTKEY_LIST_END
}

Definition at line 2157 of file toolbar_gui.cpp.